package hay.component;

import java.util.ArrayList;
import java.util.Calendar;
import android.content.ContentResolver;
import android.content.ContentValues;
import android.database.Cursor;
import android.provider.ContactsContract;
import android.provider.ContactsContract.Data;
import android.provider.ContactsContract.CommonDataKinds.Event;
import android.util.Log;

public class HayAnniversaryAdapter {

	ContentResolver cr;

	public HayAnniversaryAdapter(ContentResolver cr) {
		this.cr = cr;
	}

	public ArrayList<HayAnniversary> getBirthdays(int contact_id){
		ArrayList<HayAnniversary> birtydays = new ArrayList<HayAnniversary>();

		//, DB ´.
		Cursor cursor = cr.query(
				Data.CONTENT_URI,
				new String[]{"data1","data2","data14","data15",Event.RAW_CONTACT_ID,ContactsContract.Data._ID},
				Data.MIMETYPE + "=? AND "+Event.CONTACT_ID+"=?",
				new String[] {Event.CONTENT_ITEM_TYPE,(contact_id+"")},
				null);

		//  Ʈ ´.
		while(cursor.moveToNext()){
			
			HayAnniversary birthday =  new HayAnniversary();

			// ´.
			String date = cursor.getString(0);
			Log.d("mytag", date);
			// ־ϰ 10(2004-02-32)Ѵ.
			if(date != null && (date.length()==10)){

				//Ÿ ´.
				int type = cursor.getInt(1);

				//̸
				String text = cursor.getString(2);
				if(text==null) text="";
				
				// ´.  null
				String lunar = cursor.getString(3);

				//⺻  
				boolean lunar_flag=false;

				int remain,lunar_year = 0,lunar_month = 0,lunar_day = 0,year,month,day;

				//s ̸ ǾǷ....ǰ ˻ؾ
				if(lunar != null ){



					//0̶  .
					if(lunar.equals("0")){
						month =Integer.parseInt(date.substring(5, 7));
						day = Integer.parseInt(date.substring(8, 10));
					}
					//1̶  .
					else{
						lunar_flag=true; // 
						LunarCheck lunarcheck = new LunarCheck();

						//³¥ .
						lunar_year = Integer.parseInt(date.substring(0, 4));
						lunar_month = Integer.parseInt(date.substring(5, 7));
						lunar_day = Integer.parseInt(date.substring(8, 10));

						// ȯѴ.
						long count = lunarcheck.countLunarDay(lunar_year,lunar_month,lunar_day,false);
						String lunarString = lunarcheck.countToDateForSolar(count);

						// ->  ¥ Ѵ.
						month = Integer.parseInt(lunarString.substring(5, 7));
						day = Integer.parseInt(lunarString.substring(8, 10));
					}
				}
				else{ //  ٸ  Ѵ.
					month =Integer.parseInt(date.substring(5, 7));
					day = Integer.parseInt(date.substring(8, 10));
				}

				
				//, Ȥ ' ȯ 'κ ϱ  Ⱓ .
				remain = nowMinusget(month,day);

				
				
				year = Integer.parseInt(date.substring(0, 4));

				int rawcontact_id = cursor.getInt(4);
				int _id = cursor.getInt(5);

				//
				birthday.setRawcontact_id(rawcontact_id); //contact_id
				birthday.setType(type);
				birthday.setLunar(lunar_flag);
				birthday.setRemain(remain);
				birthday.setText(text);
				birthday.setId(_id);

				//̸ ׳ 
				if(lunar_flag == false ){
					birthday.setYear(year);
					birthday.setMonth(month);
					birthday.setDay(day);
				}
				else{ //̸ Ʊ ޾Ƴ 
					birthday.setYear(lunar_year);
					birthday.setMonth(lunar_month);
					birthday.setDay(lunar_day);
				}

				birtydays.add(birthday);
			}
		}

		return birtydays;
	}

	public ArrayList<HayAnniversary> getBirthdays(int previous,int after){

		ArrayList<HayAnniversary> birtydays = new ArrayList<HayAnniversary>();

		//, DB ´.
		Cursor cursor = cr.query(
				Data.CONTENT_URI,
				new String[]{"data1","data2","data14","data15",Event.RAW_CONTACT_ID,ContactsContract.Data._ID},
				Data.MIMETYPE + "=?",
				new String[] {Event.CONTENT_ITEM_TYPE},
				null);

		//  Ʈ ´.
		while(cursor.moveToNext()){

			HayAnniversary birthday =  new HayAnniversary();

			// ´.
			String date = cursor.getString(0);
			
			// ־ϰ 10(2004-02-32)Ѵ.
			if(date != null && (date.length()==10)){

				//Ÿ ´.
				int type = cursor.getInt(1);

				//̸
				String text = cursor.getString(2);
				if(text==null) text="";
				
				// ´.  null
				String lunar = cursor.getString(3);

				//⺻  
				boolean lunar_flag=false;

				int remain,lunar_year = 0,lunar_month = 0,lunar_day = 0,year,month,day;

				//s ̸ ǾǷ....ǰ ˻ؾ
				if(lunar != null ){



					//0̶  .
					if(lunar.equals("0")){
						month =Integer.parseInt(date.substring(5, 7));
						day = Integer.parseInt(date.substring(8, 10));
					}
					//1̶  .
					else{
						lunar_flag=true; // 
						LunarCheck lunarcheck = new LunarCheck();

						//³¥ .
						lunar_year = Integer.parseInt(date.substring(0, 4));
						lunar_month = Integer.parseInt(date.substring(5, 7));
						lunar_day = Integer.parseInt(date.substring(8, 10));

						// ȯѴ.
						long count = lunarcheck.countLunarDay(lunar_year,lunar_month,lunar_day,false);
						String lunarString = lunarcheck.countToDateForSolar(count);

						// ->  ¥ Ѵ.
						month = Integer.parseInt(lunarString.substring(5, 7));
						day = Integer.parseInt(lunarString.substring(8, 10));
					}
				}
				else{ //  ٸ  Ѵ.
					month =Integer.parseInt(date.substring(5, 7));
					day = Integer.parseInt(date.substring(8, 10));
				}

				//, Ȥ ' ȯ 'κ ϱ  Ⱓ .
				remain = nowMinusget(month,day);

				//7Ϲۿ ȳҰų, 3Ϲۿ ų
				if( remain < after && remain > -previous){

					year = Integer.parseInt(date.substring(0, 4));

					int rawcontact_id = cursor.getInt(4);
					int _id = cursor.getInt(5);

					//
					birthday.setRawcontact_id(rawcontact_id); //contact_id
					birthday.setType(type);
					birthday.setLunar(lunar_flag);
					birthday.setRemain(remain);
					birthday.setText(text);
					birthday.setId(_id);

					//̸ ׳ 
					if(lunar_flag == false ){
						birthday.setYear(year);
						birthday.setMonth(month);
						birthday.setDay(day);
					}
					else{ //̸ Ʊ ޾Ƴ 
						birthday.setYear(lunar_year);
						birthday.setMonth(lunar_month);
						birthday.setDay(lunar_day);
					}

					birtydays.add(birthday);
				}
			}
		}
		
		return birtydays;
	}
	
	public String addAnniversary(int contact_id,int year,int month,int day, int type,String name,boolean lunar){
		String raw_contact_id;
		Cursor cursor = cr.query(
				ContactsContract.RawContacts.CONTENT_URI,  
				new String[] {ContactsContract.RawContacts._ID},
				ContactsContract.RawContacts.CONTACT_ID+"="+contact_id,
				null,
				null);
		
		if(cursor.moveToNext()){
			raw_contact_id = cursor.getString(0);
		}
		else{
			return null;
		}
		
		String smonth;
		String sday;
		
		
		if( month <10)
			smonth = '0'+Integer.toString(month);
		else
			smonth = Integer.toString(month);
		if( day <10)
			sday = '0'+Integer.toString(day);
		else
			sday = Integer.toString(day);
		
		ContentValues values = new ContentValues();
		values.clear();
		values.put(ContactsContract.Data.RAW_CONTACT_ID,raw_contact_id);
		values.put(ContactsContract.Data.MIMETYPE, ContactsContract.CommonDataKinds.Event.CONTENT_ITEM_TYPE);
		values.put(ContactsContract.Data.DATA1, year+"-"+smonth+"-"+sday);
		values.put(ContactsContract.Data.DATA2, type);
		values.put(ContactsContract.Data.DATA14, name);
		values.put(ContactsContract.Data.DATA15, (lunar==true)?"1":"0");

		return cr.insert(ContactsContract.Data.CONTENT_URI, values).getLastPathSegment();
	}

	/**
	 * Ѿ ¥  ¥ Ͽ  Ҵ ˷ش.
	 * @param month 
	 * @param day 
	 * @return Ҵٸ , ٸ 
	 */
	private int nowMinusget(int month, int day){
		Calendar calendar = Calendar.getInstance();

		int now_month = calendar.get(Calendar.MONTH)+1;
		int now_day = calendar.get(Calendar.DAY_OF_MONTH);

		calendar.set(2000, now_month, now_day);
		long now = calendar.getTimeInMillis();
		calendar.set(2000, month, day);
		long get = calendar.getTimeInMillis();

		int value = (int)((now-get)/1000/60/60/24);

		return value;
	}
}
