package hay.database;

import android.content.ContentValues;
import android.content.Context;
import android.database.Cursor;
import android.database.SQLException;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;
import android.util.Log;

public class HayDatabase {

	private static final String TAG = "DB_Adapter";

	private DatabaseHelper mDbHelper;
	private SQLiteDatabase mDb;

	// ̺  
	private static final String Addition_TABLE_CREATE = "create table addition ("
		+ " contact_id integer primary key,"
		+ " twitter_id varchar(20),"
		+ " me2day_id varchar(20),"
		+ " favorite boolean not null,"
		+ " score integer not null,"
		+ " contactnumber integer not null,"
		+ " lasttime long not null);";

	// Ÿ̽ ̸
	private static final String DATABASE_NAME = "HowAreYou";

	// ̺ ̸
	private static final String Addition_TABLE = "addition";

	// ̺ ʵ
	private static final String ATTRIBUTE_Addition_CONTACT_ID = "contact_id";
	private static final String ATTRIBUTE_Addition_TWITTERID = "twitter_id";
	private static final String ATTRIBUTE_Addition_ME2DAY = "me2day_id";
	private static final String ATTRIBUTE_Addition_FAVORITE = "favorite";
	private static final String ATTRIBUTE_Addition_SCORE = "score";
	private static final String ATTRIBUTE_Addition_CONTACTNUMBER = "contactnumber";
	private static final String ATTRIBUTE_Addition_LASTTIME = "lasttime";

	// 
	private static final int DATABASE_VERSION = 1;

	private final Context mCtx;

	private static class DatabaseHelper extends SQLiteOpenHelper {

		// 
		DatabaseHelper(Context context) {
			super(context, DATABASE_NAME, null, DATABASE_VERSION);
		}

		// ͺ̽ ó    ѹ ȴ.
		public void onCreate(SQLiteDatabase db) {
			// 츮  ̺   
			db.execSQL(Addition_TABLE_CREATE);
		}

		// Ÿ ̽ ׷̵尡 ʿ  
		public void onUpgrade(SQLiteDatabase db, int oldVersion, int newVersion) {
			Log.w(TAG, "Upgrading database from version " + oldVersion + " to "
					+ newVersion + ", which will destroy all old data");
			onCreate(db);
		}
	}

	public HayDatabase(Context ctx) {
		this.mCtx = ctx;
	}

	public HayDatabase open() throws SQLException {
		mDbHelper = new DatabaseHelper(mCtx); // ۸ 
		mDb = mDbHelper.getWritableDatabase(); // ۷κ  ͼ ̰ ض.
		return this;
	}

	/**
	 * Ÿ̽ ݱ.
	 */
	public void close() {
		mDbHelper.close();
	}

	public long insertAddtion(int contact_id) {

		// initialValues  ͸ Ƶд.
		ContentValues args = new ContentValues();

		args.put(ATTRIBUTE_Addition_CONTACT_ID, contact_id);
		args.put(ATTRIBUTE_Addition_FAVORITE, false);
		args.put(ATTRIBUTE_Addition_SCORE, 100);
		args.put(ATTRIBUTE_Addition_CONTACTNUMBER, 0);
		args.put(ATTRIBUTE_Addition_LASTTIME, Long.MAX_VALUE);

		return mDb.insert(Addition_TABLE, null, args);
	}

	public long insertAddtionAll(int contact_id, String twitter, String metoday) {
		// initialValues  ͸ Ƶд.
		ContentValues args = new ContentValues();
		args.put(ATTRIBUTE_Addition_CONTACT_ID, contact_id);
		args.put(ATTRIBUTE_Addition_TWITTERID, twitter);
		args.put(ATTRIBUTE_Addition_ME2DAY, metoday);
		args.put(ATTRIBUTE_Addition_FAVORITE, false);
		args.put(ATTRIBUTE_Addition_SCORE, 100);
		args.put(ATTRIBUTE_Addition_CONTACTNUMBER, 0);
		args.put(ATTRIBUTE_Addition_LASTTIME, Long.MAX_VALUE);

		return mDb.insert(Addition_TABLE, null, args);
	}

	public Cursor fetchAddtion(boolean desc) throws SQLException {
		String orderby;
		if (desc)
			orderby = "desc";
		else
			orderby = "asc";

		Cursor mCursor = mDb.query(Addition_TABLE, new String[] {
				ATTRIBUTE_Addition_CONTACT_ID,
				ATTRIBUTE_Addition_SCORE}, null, null, null, null,
				ATTRIBUTE_Addition_SCORE + " " + orderby, null);
		return mCursor;
	}

	public Cursor fetchAddtion() throws SQLException {
		Cursor mCursor = mDb.query(Addition_TABLE, new String[] {
				ATTRIBUTE_Addition_CONTACT_ID,
				ATTRIBUTE_Addition_SCORE,
				ATTRIBUTE_Addition_LASTTIME}, null, null, null, null,
				null, null);
		return mCursor;
	}
	
	public Cursor fetchAddtionID(int contact_id) throws SQLException {

		Cursor mCursor = mDb.query(Addition_TABLE, new String[] {
				ATTRIBUTE_Addition_CONTACT_ID,
				ATTRIBUTE_Addition_SCORE,
				ATTRIBUTE_Addition_LASTTIME,
				ATTRIBUTE_Addition_TWITTERID,
				ATTRIBUTE_Addition_ME2DAY,
				ATTRIBUTE_Addition_CONTACTNUMBER,}, 
				ATTRIBUTE_Addition_CONTACT_ID + " = " + contact_id,
				null, null, null, null, null);
		return mCursor;
	}

	public boolean updateScore(int contact_id, int score) {
		ContentValues args = new ContentValues();
		args.put(ATTRIBUTE_Addition_SCORE, score);
		return mDb.update(Addition_TABLE, args, ATTRIBUTE_Addition_CONTACT_ID
				+ " = " + contact_id, null) > 0;
	}

	public boolean updateLastTime(int contact_id, long lasttime) {
		ContentValues args = new ContentValues();
		args.put(ATTRIBUTE_Addition_LASTTIME, lasttime);
		return mDb.update(Addition_TABLE, args, ATTRIBUTE_Addition_CONTACT_ID
				+ " = " + contact_id, null) > 0;
	}

	public boolean updateIncrementContactNumber(int contact_id, int count) {
		String sql;
		sql=("UPDATE addition SET contactnumber = contactnumber+"+count+" where  contact_id = "+contact_id+";");
		try{
			mDb.execSQL(sql);
			return true;
		}catch(SQLException e){
			return false;
		}
	}

	public boolean updateAddtion(int contact_id, String twitter, String me2day) {

		ContentValues args = new ContentValues();

		args.put(ATTRIBUTE_Addition_TWITTERID, twitter);
		args.put(ATTRIBUTE_Addition_ME2DAY, me2day);

		return mDb.update(Addition_TABLE, args, ATTRIBUTE_Addition_CONTACT_ID
				+ " = '" + contact_id + "'", null) > 0;
	}

	public Cursor fetchScoreAndLasttime(int contact_id) throws SQLException {

		Cursor mCursor = mDb.query(
				Addition_TABLE,
				new String[] {
						ATTRIBUTE_Addition_SCORE,
						ATTRIBUTE_Addition_LASTTIME },
						ATTRIBUTE_Addition_CONTACT_ID + " = " + contact_id,
						null, null,null, null, null);

		return mCursor;
	}

	/**
	 * ش contact_id  ´. 
	 * @param contact_id ּҷ ̵
	 * @return ش ̵ , ش ̵ ٸ -1 Ѵ.
	 * @throws SQLException Databases ó  ߻ 
	 */
	public int fetchScore(int contact_id) throws SQLException {

		Cursor mCursor = mDb.query(
				Addition_TABLE,
				new String[] {ATTRIBUTE_Addition_SCORE},
				ATTRIBUTE_Addition_CONTACT_ID + " = " + contact_id,
				null, null,	null, null, null);

		if(mCursor.moveToNext()){
			int score = mCursor.getInt(0);
			mCursor.close();
			return score;
		}
		else{
			mCursor.close();
			return -1;
		}
	}

	public boolean deleteAddition(int contact_id){

		return mDb.delete(
				Addition_TABLE,
				ATTRIBUTE_Addition_CONTACT_ID + " = " + contact_id,
				null
		) > 0;

	}
}
